/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { ScatterBase } from "./ScatterBase";
import { IScaleLegendSeries_$type } from "igniteui-angular-core";
import { ISupportsSizeScale_$type } from "./ISupportsSizeScale";
import { ISupportsFillScale_$type } from "./ISupportsFillScale";
import { Base, typeCast, Point_$type, fromEnum, markType, markDep, enumGetBox, runOn } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { UIElement } from "igniteui-angular-core";
import { ActualRange } from "./ActualRange";
import { DependencyProperty } from "igniteui-angular-core";
import { SizeScale } from "./SizeScale";
import { BrushScale } from "./BrushScale";
import { ScatterFrame } from "./ScatterFrame";
import { IChartLegend_$type } from "igniteui-angular-core";
import { ValueBrushScale } from "./ValueBrushScale";
import { IFastItemsSource_$type } from "igniteui-angular-core";
import { ScatterBaseView } from "./ScatterBaseView";
import { ScalerParams } from "./ScalerParams";
import { Dictionary$2 } from "igniteui-angular-core";
import { OwnedPoint } from "./OwnedPoint";
import { BubbleMarkerManager } from "./BubbleMarkerManager";
import { IChartItemLegend_$type } from "igniteui-angular-core";
import { IChartScaleLegend_$type } from "igniteui-angular-core";
import { ContentControl } from "igniteui-angular-core";
import { DataContext } from "igniteui-angular-core";
import { DeviceUtils } from "igniteui-angular-core";
import { BrushUtil } from "igniteui-angular-core";
import { ChartSelection } from "./ChartSelection";
import { FastItemsSource } from "igniteui-angular-core";
import { FastItemColumn } from "igniteui-angular-core";
import { DataLegendSeriesValueInfo } from "igniteui-angular-core";
import { DataLegendSeriesContext } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { isNaN_, isInfinity, logBase } from "igniteui-angular-core";
import { stringIsNullOrEmpty } from "igniteui-angular-core";
import { BrushSelectionMode_$type } from "./BrushSelectionMode";
import { ScatterTrendLineManager } from "./ScatterTrendLineManager";
import { Defaults } from "./Defaults";
/**
 * @hidden
 */
var BubbleSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(BubbleSeries, _super);
    function BubbleSeries() {
        var _this = _super.call(this) || this;
        _this.aer = null;
        _this.aeq = null;
        _this.ade = null;
        _this.ac5 = null;
        _this.ac4 = null;
        _this.ac3 = null;
        _this.ac1 = null;
        _this.ab = BubbleSeries.$;
        _this.zc = new ScatterFrame();
        _this.ze = new ScatterFrame();
        _this.za = new ScatterFrame();
        return _this;
    }
    BubbleSeries.prototype.bk = function () {
        return new BubbleSeries();
    };
    BubbleSeries.prototype.get_ek = function () {
        return true;
    };
    BubbleSeries.prototype.ct = function () {
        return new BubbleSeriesView(this);
    };
    BubbleSeries.prototype.q7 = function (a) {
        _super.prototype.q7.call(this, a);
        this.ac0 = a;
    };
    BubbleSeries.prototype.jo = function () {
        return 0.7;
    };
    BubbleSeries.prototype.xb = function () {
        if (this.xa == 0) {
            return 2;
        }
        return _super.prototype.xb.call(this);
    };
    BubbleSeries.prototype.isAttachedTo = function (a) {
        return this.a5 == a;
    };
    BubbleSeries.prototype.ej = function () {
        return true;
    };
    BubbleSeries.prototype.p8 = function (a) {
        _super.prototype.p8.call(this, a);
        if (this.ac9 != null && this.ade != null && this.ade.count > 0) {
            for (var b = 0; b < this.ade.count; b++) {
                a(this.ade._inner[b]);
            }
        }
    };
    Object.defineProperty(BubbleSeries.prototype, "ac8", {
        get: function () {
            return this.ada;
        },
        enumerable: false,
        configurable: true
    });
    BubbleSeries.prototype.get_isColoredItemwise = function () {
        return this.ac6 != null && this.ac6.count > 0;
    };
    BubbleSeries.prototype.aep = function (a) {
        var b = typeCast(CustomPaletteBrushScale.$, this.acz);
        var c = typeCast(ValueBrushScale.$, this.acz);
        var d = this.acz;
        if (b != null && this.dp != null) {
            return b.getBrush1(a, this.dp.count);
        }
        else if (c != null) {
            return c.getBrushByIndex(a, this.ac6);
        }
        else if (d != null) {
            return d.getBrush(a);
        }
        return null;
    };
    Object.defineProperty(BubbleSeries.prototype, "legendReady", {
        get: function () {
            return this.ada != null && this.ada.count != 0;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BubbleSeries.prototype, "minScaleText", {
        get: function () {
            var a = this.acy(this.ac2).b;
            return (Math.round(a * 1000) / 1000).toString();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BubbleSeries.prototype, "maxScaleText", {
        get: function () {
            var a = this.acy(this.ac2).a;
            return (Math.round(a * 1000) / 1000).toString();
        },
        enumerable: false,
        configurable: true
    });
    BubbleSeries.prototype.forScaleColors = function (a) {
        for (var b = 0; b < this.ada.count; b++) {
            if (this.acz == null || !this.acz.isReady) {
                return false;
            }
            var c = NaN;
            if (this.ac6 != null) {
                c = (this.ac6.item(b) - this.ac6.minimum) / (this.ac6.maximum - this.ac6.minimum);
            }
            var d = (this.ada.item(b) - this.ada.minimum) / (this.ada.maximum - this.ada.minimum);
            if (isNaN_(c)) {
                c = 0;
            }
            if (isNaN_(d)) {
                d = c;
            }
            var e = this.yr;
            var f = this.aep(b);
            var g = f != null ? f : e;
            a(g, d);
        }
        return true;
    };
    BubbleSeries.prototype.ku = function (a, b) {
        var c = this.ni(b);
        if (c == BubbleSeries.$$p[5]) {
            return this.kv(a, b, this.adt);
        }
        if (c == BubbleSeries.$$p[11]) {
            return this.kv(a, b, this.ad3);
        }
        if (c == ScatterBase.$$p[12]) {
            return this.kv(a, b, this.aa3);
        }
        if (c == ScatterBase.$$p[16]) {
            return this.kv(a, b, this.abb);
        }
        if (c == BubbleSeries.$$p[2]) {
            return this.kv(a, b, this.ado);
        }
        return _super.prototype.ku.call(this, a, b);
    };
    BubbleSeries.prototype.mi = function (a) {
        var b = this.ni(a);
        if (b == BubbleSeries.$$p[5]) {
            return this.adt;
        }
        if (b == BubbleSeries.$$p[11]) {
            return this.ad3;
        }
        if (b == ScatterBase.$$p[12]) {
            return this.aa3;
        }
        if (b == ScatterBase.$$p[16]) {
            return this.abb;
        }
        if (b == BubbleSeries.$$p[2]) {
            return this.ado;
        }
        return _super.prototype.mi.call(this, a);
    };
    Object.defineProperty(BubbleSeries.prototype, "ada", {
        get: function () {
            return this.ac5;
        },
        set: function (a) {
            if (this.ac5 != a) {
                var b = this.ada;
                this.ac5 = a;
                this.raisePropertyChanged("RadiusColumn", b, this.ada);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BubbleSeries.prototype, "ac9", {
        get: function () {
            return this.ac4;
        },
        set: function (a) {
            if (this.ac4 != a) {
                var b = this.ac9;
                this.ac4 = a;
                this.raisePropertyChanged("LabelColumn", b, this.ac9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BubbleSeries.prototype, "ac6", {
        get: function () {
            return this.ac3;
        },
        set: function (a) {
            if (this.ac3 != a) {
                var b = this.ac6;
                this.ac3 = a;
                this.raisePropertyChanged("FillColumn", b, this.ac6);
            }
        },
        enumerable: false,
        configurable: true
    });
    BubbleSeries.prototype.abe = function (a, b, c, d, e) {
        if (c <= this.aaj) {
            b.g = new Dictionary$2(Base.$, OwnedPoint.$, 1, c);
        }
        var f = this.aaj;
        var g = this.dp;
        var h;
        var i;
        var j = this.getEffectiveViewport1(a);
        var k = new ScalerParams(0, d, e, this.y6.d, j);
        var l = new ScalerParams(0, d, e, this.y6.e, j);
        var m = false;
        var n = 0;
        if (this.dc != null) {
            if (this.dc.gl()) {
                var o = this.dc.n1(d, k);
                m = o.c;
                n = o.d;
            }
        }
        var _loop_1 = function (p) {
            h = this_1.zr.item(p);
            i = this_1.zs.item(p);
            var q = { $type: Point_$type, x: this_1.y6.a.ft(h, k), y: this_1.y6.b.ft(i, l) };
            if (m) {
                if (q.x < e.left || q.x > e.right) {
                    if (q.x + n >= e.left && q.x + n <= e.right) {
                        q = { $type: Point_$type, x: q.x + n, y: i };
                    }
                }
            }
            if (!isInfinity(q.x) && !isInfinity(q.y)) {
                var r_1 = g.item(p);
                if (c <= f) {
                    if (!b.g.containsKey(r_1)) {
                        var s_1 = { $type: Point_$type, x: h, y: i };
                        b.g.addItem(r_1, ((function () {
                            var $ret = new OwnedPoint();
                            $ret.a = r_1;
                            $ret.b = s_1;
                            $ret.c = q;
                            return $ret;
                        })()));
                    }
                }
            }
        };
        var this_1 = this;
        for (var p = 0; p < c; p++) {
            _loop_1(p);
        }
    };
    BubbleSeries.prototype.abp = function (a, b) {
        var c = typeCast(BubbleSeriesView.$, b);
        var d = c.dd;
        d.m = this.ada;
        _super.prototype.abp.call(this, a, b);
        var e = Math.min(this.zr != null ? this.zr.count : 0, this.zs != null ? this.zs.count : 0);
        if (e < 1) {
            return;
        }
        c.d0();
        c.d1();
    };
    BubbleSeries.prototype.ad8 = function () {
        if (this.dc == null) {
            return;
        }
        if (this.a5 == null) {
            return;
        }
        if (this.a5.isItemwise) {
            var a = this.a5;
            this.a5.clearLegendItemsForSeries(this);
            this.ad7();
            a.renderItemwiseContent(this);
        }
        if (this.a5.isScale) {
            var b = this.a5;
            b.restoreOriginalState();
            b.initializeLegend(this);
        }
    };
    BubbleSeries.adf = function (a, b, c, d, e) {
        if (e <= a || isNaN_(e) || isInfinity(e)) {
            return c;
        }
        if (e >= b) {
            return d;
        }
        var f = c + ((d - c) / (b - a)) * (e - a);
        return f;
    };
    BubbleSeries.adg = function (a, b, c, d, logBase_, e) {
        var f = logBase(e, logBase_);
        var g = logBase(a, logBase_);
        var h = logBase(b, logBase_);
        return BubbleSeries.adf(g, h, c, d, f);
    };
    BubbleSeries.prototype.hf = function (a, b, c) {
        var d = _super.prototype.hf.call(this, a, b, c);
        if (this.ada == null || this.dp == null || this.ada.count == 0 || this.dp.count != this.ada.count) {
            d = false;
        }
        return d;
    };
    BubbleSeries.prototype.z1 = function (a, b) {
        if (b != 3) {
            return true;
        }
        if (a == null) {
            return true;
        }
        if (this.aa3 == a || this.abb == a || this.ad3 == a) {
            return true;
        }
        return false;
    };
    BubbleSeries.prototype.ad7 = function () {
        var _this = this;
        var a = typeCast(IChartLegend_$type, this.a5);
        if (a == null || this.dp == null) {
            return;
        }
        this.ade = new List$1(UIElement.$, 0);
        var b = typeCast(CustomPaletteBrushScale.$, this.acz);
        var c = typeCast(ValueBrushScale.$, this.acz);
        var d = this.acz;
        var e = this.acx();
        var f = e.b;
        var g = e.a;
        var h = this.dp;
        var _loop_2 = function (i) {
            var j = null;
            if (c != null && this_2.ac6 != null) {
                var k = this_2.ac6.item(i);
                j = c.getBrushByRange(k, f, g);
            }
            else if (b != null) {
                j = b.getBrush1(i, h.count);
            }
            else if (d != null) {
                j = d.getBrush(i);
            }
            var l = new ContentControl();
            var m = this_2.ac9 != null && this_2.ac9.item(i) != null ? this_2.ac9.item(i).toString() : "";
            l.content = ((function () {
                var $ret = new DataContext();
                $ret.series = _this;
                $ret.item = h.item(i);
                $ret.itemBrush = j;
                $ret.itemLabel = m;
                $ret.legendLabel = m;
                return $ret;
            })());
            var n = this_2.s5;
            if (n == null) {
                n = this_2.cw.bz(this_2.c1);
            }
            l.ah = n;
            this_2.ade.add(l);
        };
        var this_2 = this;
        for (var i = 0; i < h.count; i++) {
            _loop_2(i);
        }
    };
    BubbleSeries.prototype.ph = function (a, b, c, d) {
        _super.prototype.ph.call(this, a, b, c, d);
        if (this.ac2 != null) {
            this.ac2.aa();
        }
        if (this.acz != null) {
            this.acz.x();
        }
        this.ad8();
    };
    BubbleSeries.prototype.qj = function () {
        _super.prototype.qj.call(this);
        this.ad8();
    };
    BubbleSeries.prototype.qq = function () {
        _super.prototype.qq.call(this);
        this.ad8();
    };
    BubbleSeries.prototype.rg = function (a, b, c, d) {
        var e_1, _a;
        _super.prototype.rg.call(this, a, b, c, d);
        switch (b) {
            case ScatterBase.$$p[10]:
            case ScatterBase.$$p[14]:
            case ScatterBase.$$p[11]:
            case ScatterBase.$$p[15]:
            case BubbleSeries.$$p[9]:
            case BubbleSeries.$$p[10]:
                this.ql();
                break;
            case "FastItemsSource":
                if (this.ac2 != null) {
                    this.ac2.aa();
                }
                if (this.acz != null) {
                    this.acz.x();
                }
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    c.deregisterColumn(this.ada);
                    c.deregisterColumn(this.ac6);
                    c.deregisterColumn(this.ac9);
                    this.ada = null;
                    this.ac6 = null;
                    this.ac9 = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    this.ada = this.dl(this.ad3);
                    if (!stringIsNullOrEmpty(this.ado)) {
                        this.ac6 = this.dl(this.ado);
                    }
                    this.ac9 = this.dn(this.adt);
                }
                this.ry(false);
                this.ad8();
                break;
            case BubbleSeries.$$p[11]:
                if (this.ac2 != null) {
                    this.ac2.aa();
                }
                if (this.dp != null) {
                    this.dp.deregisterColumn(this.ada);
                    this.ada = this.dl(this.ad3);
                    this.ad8();
                }
                break;
            case "RadiusColumn":
                if (this.ac2 != null) {
                    this.ac2.aa();
                }
                this.y7.df.g$m();
                this.ry(this.gh && this.d9);
                this.qs();
                break;
            case BubbleSeries.$$p[12]:
                if (c != null) {
                    c.l.remove(this);
                    c.aa();
                }
                if (d != null) {
                    d.l.add(this);
                    d.aa();
                }
                this.ry(false);
                this.qr();
                break;
            case BubbleSeries.$$p[13]:
                this.ry(false);
                this.qr();
                break;
            case "DiscreteLegendItemTemplate":
                this.ad8();
                break;
            case BubbleSeries.$$p[3]:
                if (c != null) {
                    c.o.remove(this);
                    c.x();
                }
                if (d != null) {
                    d.o.add(this);
                    d.x();
                }
                this.ry(false);
                this.ad8();
                this.qr();
                break;
            case BubbleSeries.$$p[4]:
            case BubbleSeries.$$p[8]:
            case BubbleSeries.$$p[7]:
            case BubbleSeries.$$p[6]:
                this.ry(false);
                this.ad8();
                this.qr();
                break;
            case "FillColumn":
                this.ry(this.gh && this.d9);
                this.qr();
                break;
            case BubbleSeries.$$p[2]:
                if (this.acz != null) {
                    this.acz.x();
                }
                if (this.dp != null) {
                    this.dp.deregisterColumn(this.ac6);
                    this.ac6 = this.dl(this.ado);
                    this.ad8();
                }
                break;
            case BubbleSeries.$$p[5]:
                if (this.dp != null) {
                    this.dp.deregisterColumn(this.ac9);
                    this.ac9 = this.dn(this.adt);
                    this.ad8();
                }
                break;
            case "ActualLegend":
                var e = typeCast(IChartLegend_$type, c);
                if (e != null && e.isItemwise) {
                    var f = typeCast(IChartItemLegend_$type, e);
                    f.clearLegendItemsForSeries(this);
                }
                if (e != null && e.isScale) {
                    var g = typeCast(IChartScaleLegend_$type, e);
                    var h = true;
                    var i = null;
                    if (this.dc != null) {
                        try {
                            for (var _b = __values(fromEnum(this.dc.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                                var j = _c.value;
                                if (j.legend == g) {
                                    i = j;
                                    h = false;
                                }
                            }
                        }
                        catch (e_1_1) {
                            e_1 = { error: e_1_1 };
                        }
                        finally {
                            try {
                                if (_c && !_c.done && (_a = _b.return))
                                    _a.call(_b);
                            }
                            finally {
                                if (e_1)
                                    throw e_1.error;
                            }
                        }
                    }
                    if (h) {
                        g.restoreOriginalState();
                    }
                    else {
                        g.initializeLegend(typeCast(IScaleLegendSeries_$type, i));
                    }
                }
                this.ad8();
                break;
            case "SeriesViewer":
                this.ad8();
                break;
        }
    };
    BubbleSeries.prototype.updateSizeScaleGlobals = function () {
        var a = new ActualRange();
        a.b = NaN;
        a.a = NaN;
        if (this.ada != null) {
            a.b = this.ada.minimum;
            a.a = this.ada.maximum;
        }
        if (this.ac2 != null) {
            this.ac2.ab(a.b, a.a);
        }
    };
    BubbleSeries.prototype.updateFillScaleGlobals = function () {
        var a = new ActualRange();
        a.b = NaN;
        a.a = NaN;
        if (this.ac6 != null) {
            a.b = this.ac6.minimum;
            a.a = this.ac6.maximum;
        }
        if (this.acz != null) {
            this.acz.z(a.b, a.a);
        }
    };
    BubbleSeries.prototype.acy = function (a) {
        var b = new ActualRange();
        b.b = NaN;
        b.a = NaN;
        if (this.ada != null) {
            b.b = this.ada.minimum;
            b.a = this.ada.maximum;
        }
        if (a != null) {
            a.x();
            if (this.add) {
                b.b = a.globalMinimum;
                b.a = a.globalMaximum;
            }
        }
        return b;
    };
    BubbleSeries.prototype.acx = function () {
        var a = new ActualRange();
        a.b = NaN;
        a.a = NaN;
        if (this.ac6 != null) {
            a.b = this.ac6.minimum;
            a.a = this.ac6.maximum;
        }
        var b = typeCast(ValueBrushScale.$, this.acz);
        if (b != null) {
            b.s();
            if (this.adb && this.acz.o.count > 1) {
                a.b = b.q;
                a.a = b.p;
            }
        }
        return a;
    };
    BubbleSeries.prototype.aea = function (a, b, c, d) {
        var e = c.width;
        if (!this.cw.b9.isEmpty) {
            e = this.cw.b9.width;
        }
        else if (this.dc != null && !this.dc.x4.isEmpty) {
            e = this.dc.x4.width;
        }
        var f = DeviceUtils.c(e);
        this.ac1 = this.ac2 || ((function () {
            var $ret = new SizeScale();
            $ret.minimumValue = f / 10;
            $ret.maximumValue = f / 5;
            return $ret;
        })());
        if (this.ac1 != null) {
            var g = this.ac1.minimumValue;
            var h = this.ac1.maximumValue;
            var i = this.ac1.logarithmBase;
            var j = this.acy(this.ac1);
            var k = j.b;
            var l = j.a;
            if (this.ac1.isLogarithmic) {
                for (var m = 0; m < b.count; m++) {
                    b._inner[m] = BubbleSeries.adg(k, l, g, h, i, b._inner[m]);
                }
            }
            else {
                for (var n = 0; n < b.count; n++) {
                    b._inner[n] = BubbleSeries.adf(k, l, g, h, b._inner[n]);
                }
            }
        }
        var o = 1;
        o = DeviceUtils.d();
        var p = this.ac2 == null;
        if (d) {
            var q = c.width / e;
            for (var r = 0; r < b.count; r++) {
                if (p) {
                    b._inner[r] = b._inner[r] / o;
                }
                b._inner[r] = b._inner[r] * q;
            }
        }
        for (var s = 0; s < a.count; s++) {
            var t = a._inner[s];
            if (p && !d) {
                t.width = Math.max(0, b._inner[s] / o);
                t.height = Math.max(0, b._inner[s] / o);
            }
            else {
                t.width = Math.max(0, b._inner[s]);
                t.height = Math.max(0, b._inner[s]);
            }
        }
    };
    BubbleSeries.prototype.ad9 = function (a) {
        var b = typeCast(BubbleSeriesView.$, this.cv);
        this.ac0.ck = false;
        if (b != null) {
            b.ck = false;
        }
        var c = typeCast(CustomPaletteBrushScale.$, this.acz);
        var d = typeCast(ValueBrushScale.$, this.acz);
        var e = this.acz;
        var f = this.acx();
        var g = f.b;
        var h = f.a;
        var i = this.acz == null || !this.acz.isReady || (d != null && this.ado == null);
        if (i) {
            this.ac0.dz();
            if (b != null) {
                b.dz();
            }
            return;
        }
        this.ac0.ck = true;
        if (b != null) {
            b.ck = true;
        }
        var j = a.count;
        var k = this.dp;
        for (var l = 0; l < j; l++) {
            var m = a._inner[l];
            var n = typeCast(DataContext.$, m.content);
            if (n != null) {
                var o = null;
                var p = k.indexOf(n.item);
                if (c != null) {
                    o = c.getBrush1(p, k.count);
                }
                else if (d != null && this.ac6 != null) {
                    var q = this.ac6.item(p);
                    o = d.getBrushByRange(q, g, h);
                }
                else if (e != null) {
                    o = e.getBrush(p);
                }
                else {
                    if (this.yt == null) {
                        o = this.yr;
                    }
                    else {
                        o = this.yt;
                    }
                }
                var r = null;
                if (this.yu == null) {
                    r = this.ys;
                }
                else {
                    r = this.yu;
                }
                if (this.adc && o != null) {
                    r = o;
                }
                if (r != null && !isNaN_(this.adi)) {
                    r = BrushUtil.o(r, this.adi);
                }
                if (o != null && !isNaN_(this.adh)) {
                    o = BrushUtil.o(o, this.adh);
                }
                n.itemBrush = o;
                n.actualItemBrush = o;
                n.outline = r;
            }
        }
    };
    BubbleSeries.prototype.ak = function (a, b) {
        var c = new List$1(ChartSelection.$, 0);
        this.qa(a, c, b);
        return c.toArray();
    };
    BubbleSeries.prototype.qa = function (a, b, c) {
        var d = 1;
        if (d == 1) {
            var e = this.ac7();
            this.abh(a, b, c, d, e);
        }
        else {
            _super.prototype.qa.call(this, a, b, c);
        }
    };
    BubbleSeries.prototype.ac7 = function () {
        var a = new FastItemColumn(typeCast(FastItemsSource.$, this.dp), "RadiusColumn", null, false);
        var b = this.cw.b9;
        var c = b.width;
        if (!this.cw.b9.isEmpty) {
            c = this.cw.b9.width;
        }
        else if (this.dc != null && !this.dc.x4.isEmpty) {
            c = this.dc.x4.width;
        }
        var d = DeviceUtils.c(c);
        this.ac1 = this.ac2 || ((function () {
            var $ret = new SizeScale();
            $ret.minimumValue = d / 10;
            $ret.maximumValue = d / 5;
            return $ret;
        })());
        if (this.ac1 != null) {
            var e = this.ac1.minimumValue;
            var f = this.ac1.maximumValue;
            var g = this.ac1.logarithmBase;
            var h = this.acy(this.ac1);
            var i = h.b;
            var j = h.a;
            if (this.ac1.isLogarithmic) {
                for (var k = 0; k < a.count; k++) {
                    a.item(k, BubbleSeries.adg(i, j, e, f, g, a.item(k)));
                }
            }
            else {
                for (var l = 0; l < a.count; l++) {
                    a.item(l, BubbleSeries.adf(i, j, e, f, a.item(l)));
                }
            }
        }
        var m = DeviceUtils.d();
        var n = this.ac2 == null;
        var o = this.cw == this.cv;
        if (o) {
            var p = b.width / c;
            for (var q = 0; q < a.count; q++) {
                if (n) {
                    a.item(q, a.item(q) / m);
                }
                a.item(q, a.item(q) * p);
            }
        }
        for (var r = 0; r < a.count; r++) {
            var s = void 0;
            if (n && !o) {
                a.item(r, Math.max(0, a.item(r) / m));
            }
            else {
                a.item(r, Math.max(0, a.item(r)));
            }
        }
        return a;
    };
    BubbleSeries.prototype.getDataLegendSeriesContextAt = function (a, b) {
        var c = { $type: Point_$type, x: a, y: b };
        var d = this.kr(c);
        var e = d == null ? NaN : this.iz(d, "XMemberPath");
        var f = d == null ? NaN : this.iz(d, "YMemberPath");
        var g = new DataLegendSeriesValueInfo();
        g.a = 13;
        g.l = e;
        g.q = "X";
        g.r = this.aa3 != null ? this.aa3 : "X";
        g.s = this.aaz != null ? this.aaz : "X:";
        g.t = this.aa1 != null ? this.aa1 : "";
        var h = new DataLegendSeriesValueInfo();
        h.l = f;
        h.a = 14;
        h.q = "Y";
        h.r = this.abb != null ? this.abb : "Y";
        h.s = this.aa7 != null ? this.aa7 : "Y:";
        h.t = this.aa9 != null ? this.aa9 : "";
        var i = new DataLegendSeriesContext();
        i.e = ((function () {
            var $ret = new List$1(DataLegendSeriesValueInfo.$, 0);
            $ret.add(g);
            $ret.add(h);
            return $ret;
        })());
        i.h = this.mh();
        if (!stringIsNullOrEmpty(this.ad3)) {
            var j = d == null ? NaN : this.iz(d, "RadiusMemberPath");
            var k = new DataLegendSeriesValueInfo();
            k.l = j;
            k.a = 11;
            k.q = "Radius";
            k.r = this.ad3 != null ? this.ad3 : "Radius";
            k.s = this.adz != null ? this.adz : "R:";
            k.t = this.ad1 != null ? this.ad1 : "";
            i.e.add(k);
        }
        else if (this.ac1 != null) {
            var l = new DataLegendSeriesValueInfo();
            l.l = this.ac1.maximumValue;
            l.a = 11;
            l.q = "Radius";
            l.r = this.ad3 != null ? this.ad3 : "Radius";
            l.s = this.adz != null ? this.adz : "R:";
            l.t = this.ad1 != null ? this.ad1 : "";
            i.e.add(l);
        }
        if (!stringIsNullOrEmpty(this.ado)) {
            var m = d == null ? NaN : this.iz(d, "FillMemberPath");
            var n = new DataLegendSeriesValueInfo();
            n.l = m;
            n.a = 12;
            n.q = "Fill";
            n.r = this.ado != null ? this.ado : "Fill";
            n.s = this.adk != null ? this.adk : "F:";
            n.t = this.adm != null ? this.adm : "";
            i.e.add(n);
        }
        return i;
    };
    Object.defineProperty(BubbleSeries.prototype, "actualMarkerBrush", {
        get: function () {
            return this.yr;
        },
        enumerable: false,
        configurable: true
    });
    BubbleSeries.$t = markType(BubbleSeries, 'BubbleSeries', ScatterBase.$, [IScaleLegendSeries_$type, ISupportsSizeScale_$type, ISupportsFillScale_$type]);
    BubbleSeries.$$p = markDep(DependencyProperty, PropertyMetadata, BubbleSeries, 'raisePropertyChanged', ['FillMemberAsLegendLabel:adk:aeb', [2, null], 'FillMemberAsLegendUnit:adm:aec', [2, null], 'FillMemberPath:ado:aed', [2], 'FillScale:acz:aee', [BrushScale.$], 'FillScaleUseGlobalValues:adb:aef', [0, false], 'LabelMemberPath:adt:aeg', [2], 'MarkerBrushBrightness:adh:aeh', [1, NaN], 'MarkerOutlineBrightness:adi:aei', [1, NaN], 'MarkerOutlineUsesFillScale:adc:aej', [0, false], 'RadiusMemberAsLegendLabel:adz:aek', [2, null], 'RadiusMemberAsLegendUnit:ad1:ael', [2, null], 'RadiusMemberPath:ad3:aem', [2, null], 'RadiusScale:ac2:aen', [SizeScale.$], 'RadiusScaleUseGlobalValues:add:aeo', [0, false]]);
    return BubbleSeries;
}(ScatterBase));
export { BubbleSeries };
/**
 * @hidden
 */
var CustomPaletteBrushScale = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CustomPaletteBrushScale, _super);
    function CustomPaletteBrushScale() {
        return _super.call(this) || this;
    }
    CustomPaletteBrushScale.prototype.getBrush1 = function (a, b) {
        if (this.brushes == null || this.brushes.count == 0) {
            return null;
        }
        if (this.brushSelectionMode == 0) {
            return _super.prototype.getBrush.call(this, a % this.brushes.count);
        }
        var c = BubbleSeries.adf(0, b - 1, 0, this.brushes.count - 1, a);
        return this.ab(c);
    };
    CustomPaletteBrushScale.prototype.get_isReady = function () {
        return this.brushes != null && this.brushes.count > 0;
    };
    CustomPaletteBrushScale.$t = markType(CustomPaletteBrushScale, 'CustomPaletteBrushScale', BrushScale.$);
    CustomPaletteBrushScale.$$p = markDep(DependencyProperty, PropertyMetadata, CustomPaletteBrushScale, 'v', ['BrushSelectionMode', [BrushSelectionMode_$type, enumGetBox(BrushSelectionMode_$type, 0)]]);
    return CustomPaletteBrushScale;
}(BrushScale));
export { CustomPaletteBrushScale };
/**
 * @hidden
 */
var BubbleSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(BubbleSeriesView, _super);
    function BubbleSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.dy = null;
        _this.dy = a;
        _this.df = new ScatterTrendLineManager();
        return _this;
    }
    BubbleSeriesView.prototype.a4 = function () {
        _super.prototype.a4.call(this);
        if (!this.t) {
            this.ch.xk = Defaults.e;
        }
    };
    BubbleSeriesView.prototype.dc = function () {
        var _this = this;
        return new BubbleMarkerManager(function (a) { return _this.dg.item(a); }, function (a) { return _this.de.y6.c.item(a); }, runOn(this, this.ds), runOn(this, this.c9), runOn(this, this.dh));
    };
    BubbleSeriesView.prototype.d0 = function () {
        var a = this.dd;
        this.dy.aea(a.n, a.o, this.b9, this == this.f.cv);
        this.a2();
    };
    BubbleSeriesView.prototype.d1 = function () {
        var a = this.dd;
        this.dy.ad9(a.n);
    };
    BubbleSeriesView.prototype.dz = function () {
        var e_2, _a;
        var a = this.dd;
        try {
            for (var _b = __values(fromEnum(a.n)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                var c = typeCast(DataContext.$, b.content);
                if (c != null) {
                    c.itemBrush = null;
                    c.outline = null;
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
    };
    BubbleSeriesView.prototype.getDefaultTooltipTemplate = function () {
        var a = "<div class='ui-chart-default-tooltip-content'><span";
        var b = this.f.ba.a$u(this.f);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        a += ">" + this.dy.title + "</span><br/><span>" + "(${item." + this.dy.aa3 + "}, ${item." + this.dy.abb + "})</span>";
        if (!stringIsNullOrEmpty(this.dy.ad3)) {
            a += "<span>, Radius: ${item." + this.dy.ad3 + "}</span>";
        }
        a += "</div>";
        return a;
    };
    BubbleSeriesView.$t = markType(BubbleSeriesView, 'BubbleSeriesView', ScatterBaseView.$);
    return BubbleSeriesView;
}(ScatterBaseView));
export { BubbleSeriesView };
